# win-vind
Simple Vim Key Binder for Windows  
<img src="https://github.com/pit-ray/pit-ray.github.io/blob/master/win-vind/imgs/win-vind-icon.png?raw=true" width="256" height="256" align="right" title="win-vind">  
<a href="https://pit-ray.github.io/win-vind/">Home Page</a>  

<br>  

## Description
**win-vind** provides the lightweight **Hybrid UI System of CUI and GUI**.  

Mainly, there are five point features.  

### 1. GUI Operation like Vim  
You can operate all windows, the mouse, virtual desktops, GUI-objects with key-bindings like Vim.  

**Example**  
<img src="https://github.com/pit-ray/pit-ray.github.io/blob/master/win-vind/imgs/EasyClickDemo.gif?raw=true" title="EasyClick-demo" width=700>

### 2. Vim emulation everywhere  
It enables to emulate Vim when using general text editors, for instance, `notepad.exe` or `Microsoft Office Word`.  

**Example**  
<img src="https://github.com/pit-ray/pit-ray.github.io/blob/master/win-vind/imgs/edi-mode-demo.gif?raw=true" />

### 3. Mode Management like Vim  
There are two main modes: **GUI Mode** for GUI operation and **Editor Mode** for Vim emulation.  

<img src="https://github.com/pit-ray/pit-ray.github.io/blob/master/win-vind/imgs/mode_overview_2.jpg?raw=true" width=700 />  

### 4. Process Control  
If you register `notepad.exe` as `notepad`, could launch it by typing `:!notepad` like below.  

**Example**  
<img src="https://github.com/pit-ray/pit-ray.github.io/blob/master/win-vind/imgs/cmd-demo.gif?raw=true" width=400 title="cmd-demo">  

### 5. Using from command line
You can operate win-vind from command lines.  

**Example**  
```bash
$ ./win-vind.exe --func change_to_normal
```
Therefore, it enables to make Vim link to GUI.  
Refer to <a href="https://pit-ray.github.io/win-vind/cheat_sheet/link_with_vim/">Link With Vim - win-vind</a>  

If you want to know the details, refer to <a href="https://pit-ray.github.io/win-vind/cheat_sheet/">Cheat Sheet - win-vind</a>.  

## How to use
Please visit <a href="https://pit-ray.github.io/win-vind/how_to_use/">How to use - win-vind</a>.  

## How to contribute
Please visit <a href="https://pit-ray.github.io/win-vind/how_to_contribute/">How to contribute - win-vind</a>.  

<!--
## Latest Log
It has differences from the latest release.
`release` is the so-called stable version.

### Fix

### Change

### New
#### General

#### Options

#### Functions

### Bugs

## ToDo

-->  

## License  
This software is provided by **MIT License**.  

## Author
- pit-ray  
[E-mail] pit-ray(at)outlook.com
